<?php
/*
  $Id: quantum_iframe.php 1813 2008-01-13 12:53:40Z hpdl $

  Released under the GNU General Public License
  
  http://www.quantumgateway.com

  by

 Jerry Brown - CDG Commerce
  support@cdgcommerce.com
  
 2015-01-26
 Added  the following to the api. - Pre populate fields
	#Billing Information
$fname, $lname, $address, $city, $state, $zip, $country, $phone, $email, 
	#Shipping information
$sfname, $slname, $saddress, $scity, $sstate, $szip, $scountry, 
$Vendor # Please only use the Vendor if you are actually a Vendor.  Vendor would be the name of the software and it is for special useage for approved partners.
$invoice_num
$trans_type #AUTH_ONLY, AUTH_CAPTURE, SALES

#Override Processing Settings return urls 
 $post_return_url_approved, $post_return_url_declined, 
#over ride gateway sending emails
$override_trans_email, $override_email_customer

2020
Added ability for RecurringCustomerEdit
Changed the post back url var to be sent at authentication rather than in the ILF / Address.

2022
Converted to version 2, where POST data is used instead of all the extrapars going into the iframe source code.
*/
 

function _quantumilf_http_post($host, $path, $data, $port = 80) {

        $req = _quantumilf_qsencode ($data);
		$response = '';
		if ( (PHP_VERSION >= 4.3) && ($fs = @fsockopen('ssl://secure.quantumgateway.com', 443, $errno, $errstr, 30)) ) {
		
			$http_request  = "POST $path HTTP/1.0\r\n";
			$http_request .= "Host: $host\r\n";
			$http_request .= "Content-Type: application/x-www-form-urlencoded;\r\n";
			$http_request .= "Content-Length: " . strlen($req) . "\r\n";
			$agent = "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:34.0) Gecko/20100101 Firefox/34.0";
			$http_request .= "User-Agent: $agent\r\n";
			$http_request .= "\r\n";
			$http_request .= $req;
 
		    fwrite($fs, $http_request);
			while (!feof($fs)) {
				$response .= fgets($fs, 1160); // One TCP-IP packet
			}
			
    		fclose($fs);
			$response = explode("\r\n\r\n", $response, 2);
		} elseif (function_exists('curl_exec')) {
		
			 $ch = curl_init();
			$curl_url = 'https://secure.quantumgateway.com' . $path;
			curl_setopt($ch, CURLOPT_URL, $curl_url);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_HEADER, false);
			curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_SSLVERSION, 6); 
		
			$result = curl_exec($ch);
			$response = explode("\r\n\r\n", $result, 2);
			$response[1] = $response[0];
			curl_close($ch);
			
			
		} 
        return $response;
}

function _quantumilf_qsencode ($data) {
        $req = "";
        foreach ( $data as $key => $value )
                $req .= $key . '=' . urlencode( stripslashes($value) ) . '&';

        // Cut the last '&'
        $req=substr($req,0,strlen($req)-1);
        return $req;
}



function quantumilf_getCode($API_Username='', $API_Key='', $width='700', $height='600', $method='0', $extrapars2='') {
	$thereturn = array();
	$random = rand(1111111111, 9999999999);
	$random = (int)$random;
	$version=2;
	$response = _quantumilf_http_post("secure.quantumgateway.com", "/cgi/ilf_authenticate.php",
                                          array (
                                                 'API_Username' => $API_Username,
                                                 'API_Key' => $API_Key,
                                                 'randval' => $random,
												 'lastip' => $_SERVER['REMOTE_ADDR'],
												 'v' => $version,
                                                 ), 443
                                          );
										  
					print_r($response, 1);					  
										  
								  
	if (is_array($response)) {
		if(preg_match("/error/i", $response[1])) {} else {
$to_exp=explode("|", $response[1]);
$k=$to_exp[0];
$c1=$to_exp[1];
						
//Get extra vars to post/update the ILF query

			$extrapars = '';
	if ($method != '0') {
				$extrapars .= "&METHOD=$method";	
	}

$extrapars.=$extrapars2;	
	
// Version 2 posts the extrapars using the authenticated information. When the frame is generted, then that data will be retrieved IN the frame.
if(empty($extrapars)) {} else {			
$LOGINURL = "https://secure.quantumgateway.com/cgi/ilf.php";
$agent = $_SERVER['HTTP_USER_AGENT'];
$POSTFIELDS = 
"&RequestType=PostVars".
"&v=".$version.
"&c1=".$c1.
"&k=".$k.
$extrapars;

$ch = curl_init(); 
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); 
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE); 
curl_setopt($ch, CURLOPT_FOLLOWLOCATION,1);  
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
curl_setopt($ch, CURLOPT_USERAGENT, $agent);  
curl_setopt($ch, CURLOPT_URL,$LOGINURL);
curl_setopt($ch, CURLOPT_POST, 1);  
curl_setopt($ch, CURLOPT_POSTFIELDS,$POSTFIELDS); 
	curl_setopt($ch, CURLOPT_SSLVERSION, 6);  
$result_curl = curl_exec ($ch);
curl_close ($ch); 
$mytest = $result_curl;
		
}			
//End Get extra vars to post/update the ILF query			


			
			$thereturn['iframe'] = '<iframe src="https://secure.quantumgateway.com/cgi/ilf.php?v='.$version.'&k=' . $k . '&c1=' . $c1 . '" height="' . $height . '" width="' . $width . '" frameborder="0"></iframe><br/>';	


			$thereturn['script']  = '<script src="https://secure.quantumgateway.com/javascript/prototype.js" type="text/javascript"></script>
<script type="text/javascript">
function refreshSession(thek, ther) {
	var randomnumber=Math.random();
	var tposturl = "quantum_iframe.php?cachebuster=" + randomnumber;
	var thequerystring = "ajax=true&v=2&c1=" + ther + "&k=" + thek;
	var thecheck = new Ajax.Request(tposturl, {	method: "post", parameters: thequerystring });
	
}
setInterval("refreshSession(\'v='.$version.'\',\'' . $k . '\',\'' . $c1 . '\')",20000);
</script>
';
		}
	}
	return $thereturn;
}
// The refresh keeps the customers session so it won't time out.
if (isset($_POST['ajax']))  {
	if ($_POST['ajax'] == "true") {
	$response = _quantumilf_http_post("secure.quantumgateway.com", "/cgi/ilf_refresh.php",
									  array (
											 'c1' => $_POST['c1'],
											 'k' => $_POST['k'],
											 'v' => $version
											 ), 443
									  );
	}	
}
?>